package com.fp.persistence.pgeneral.transf;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSFERSTATUS*/
@Entity(name="TgeneTransferStatus")
@Table(name="TGENETRANSFERSTATUS")
public class TgeneTransferStatus extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneTransferStatus
*/
@Id
@Column(name="CREDITTYPECODE" ,nullable=false, updatable=false)
private String pk;
@Column(name="MODULECODE", nullable=true)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="EXPIREDSTATUSCODE", nullable=true)

/**
* Estatus de cuotas que llegaron a la fecha de vencimiento.
*/
private String expiredstatuscode;

@Column(name="FUTURESTATUSCODE", nullable=true)

/**
* Estatus de cotas cuya fecha de vencimiento esta en el futuro.
*/
private String futurestatuscode;

/**Contructor por defecto*/
public TgeneTransferStatus(){
}
/**Contructor de TgeneTransferStatus
@param pPk Clave Primaria del entity
*/
public TgeneTransferStatus(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneTransferStatus
*/
public static TgeneTransferStatus find(EntityManager pEntityManager,Object pKey) throws Exception{
    TgeneTransferStatus obj = pEntityManager.find(TgeneTransferStatus.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneTransferStatus
@return El objeto que referencia a la Clave primaria de TgeneTransferStatus
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneTransferStatus
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransferStatus
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de expiredstatuscode
@return valor de expiredstatuscode*/
public String getExpiredstatuscode(){
  return expiredstatuscode;
}
/**Fija el valor de expiredstatuscode
@param pExpiredstatuscode nuevo Valor de expiredstatuscode*/
public void setExpiredstatuscode(String pExpiredstatuscode){
  expiredstatuscode=pExpiredstatuscode;
}

/**Obtiene el valor de futurestatuscode
@return valor de futurestatuscode*/
public String getFuturestatuscode(){
  return futurestatuscode;
}
/**Fija el valor de futurestatuscode
@param pFuturestatuscode nuevo Valor de futurestatuscode*/
public void setFuturestatuscode(String pFuturestatuscode){
  futurestatuscode=pFuturestatuscode;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneTransferStatus))return false;
    TgeneTransferStatus that = (TgeneTransferStatus) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneTransferStatus
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneTransferStatus
*/
public Object createInstance(){
 TgeneTransferStatus instance=new TgeneTransferStatus();	
 return instance;
}
/**Clona la entidad TgeneTransferStatus
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneTransferStatus p=(TgeneTransferStatus)this.clone();
  return p;
}
}
